package nl.amis.app.view;


import java.util.Collection;
import java.util.Date;
import java.util.concurrent.atomic.AtomicInteger;

import javax.annotation.PostConstruct;

import nl.amis.app.model.DataUpdateEventListener;
import nl.amis.app.model.DatabaseNotificationHandler;

import oracle.adf.view.rich.activedata.ActiveModelContext;
import oracle.adf.view.rich.activedata.BaseActiveDataModel;
import oracle.adf.view.rich.event.ActiveDataEntry;
import oracle.adf.view.rich.event.ActiveDataUpdateEvent;

import oracle.adf.view.rich.render.ClientEvent;

import oracle.adfinternal.view.faces.activedata.ActiveDataEventUtil;


public class EmpRefresher implements DataUpdateListenerI {

    private Boolean needsRefreshing = false;
    private DatabaseNotificationProcessor databaseNotificationProcessor ;

    
    @PostConstruct
    public void initializeBean() {
        System.out.println("add bean as listener");
        databaseNotificationProcessor.registerAsListener(this);
    }
    public void setDatabaseNotificationProcessor(DatabaseNotificationProcessor databaseNotificationProcessor) {
        this.databaseNotificationProcessor = databaseNotificationProcessor;
    }

    public DatabaseNotificationProcessor getDatabaseNotificationProcessor() {
        return databaseNotificationProcessor;
    }

    public void processDataUpdate(String payload) {
        needsRefreshing=true;
    }

    public void setNeedsRefreshing(Boolean needsRefreshing) {
        this.needsRefreshing = needsRefreshing;
    }

    public Boolean getNeedsRefreshing() {
        boolean result = needsRefreshing;
                       needsRefreshing=false;
        return result;
    }
    
    public void handleClientEventDoNothing(ClientEvent ce) {
        // do nothing; because of Change Event Policy PPR, the change in the 
        // VO (if any) should be "pushed" to the browser 'automatically'
    }
}
